from tirr.sandbox.sandbox_imports import *
import umap

def var_loss(x):
    hinge_margin = torch.tensor(0)
    gamma = 1   
    var = torch.sqrt(x.var(0)+1e-6)
    loss = torch.maximum(hinge_margin, gamma-var).mean()
    return loss


def umap_run(
    embedding="dino",
    dataset_name="inshop",
    metric_name="map",
    distance="cosine",
):
    dataset_mapping = get_dataset_mapping()

    # creating an instance of the required dataset class
    dataset = dataset_mapping[dataset_name](
        no_training=False, embed_type=embedding
    )


    metrics_mapping = get_metrics_mapping()

    metric_function = metrics_mapping[metric_name]



    proj_size = 256


  

    # recall at img1 PCA and img2 PCA
    recall_img = metric_function(
        dataset.qFeatImg1PCA[:, :proj_size].copy(),
        dataset.dbFeatImg1PCA[:, :proj_size].copy(),
        dataset.gt,
        dataset.numQ,
        k=4,
        distance=distance,
    )

    umap_obj = umap.UMAP(metric='cosine', n_components=proj_size, n_neighbors=10, min_dist=0.1)
    
    dbFeatUmap = umap_obj.fit_transform(dataset.dbFeatImg1PCA.copy())
    qFeatUmap = umap_obj.transform(dataset.qFeatImg1PCA.copy())


    recall_img_umap = metric_function(
        qFeatUmap.copy(),
        dbFeatUmap.copy(),
        dataset.gt,
        dataset.numQ,
        k=4,
        distance=distance,
    )

    print(f"Recall at {proj_size} PCA: {recall_img}")
    print(f"Recall at {proj_size} UMAP: {recall_img_umap}")




    




def main():
    umap_run(
        embedding="dinos8",
        dataset_name="pitts",
        metric_name="map",
        distance="cosine",
    )


if __name__ == "__main__":
    main()

                                                                                                                                    
