import numpy as np
import pickle
from utils.get_embeddings import clip_text, gtr_text

root_dir =  "/nas/tirr/waterbird/dataset/waterbird_landfraction50_forest2water2/"
save_dir = "/nas/tirr/waterbird/"
BATCH_SIZE = 64

if __name__ == "__main__":

    # load text files from pickle
    train_test_path_text = pickle.load(open(root_dir + 'text_descriptions_waterbird_train_test_llava13B.pkl', 'rb'))
    val_path_text = pickle.load(open(root_dir + 'text_descriptions_waterbird_val_llava13B.pkl', 'rb'))
    # for (path, text) in train_test_path_text:
    #     print(path, text)
    #     input()
    train_test_path_text = np.array([_[1].replace("</s>", "") for _ in train_test_path_text])
    val_path_text = np.array([_[1].replace("</s>", "") for _ in val_path_text])
    print("Length of train_test_path_text:", len(train_test_path_text), train_test_path_text[0])
    print("Length of val_path_text:", len(val_path_text), val_path_text[0])
    

    # get train_test embeddings
    print("Loading CLIP")
    text_emb = clip_text(train_test_path_text, 1) # batched np array
    print("CLIP embeddings done:", text_emb.shape)
    with open(save_dir + 'data/waterbird_text_emb_train_test_clip.pkl', 'wb') as f:
        pickle.dump(text_emb, f)

    print("Loading GTR")
    text_emb = gtr_text(train_test_path_text, BATCH_SIZE) # batched np array
    print("GTR embeddings done:", text_emb.shape)
    with open(save_dir + 'data/waterbird_text_emb_train_test_gtr.pkl', 'wb') as f:
        pickle.dump(text_emb, f)

    # get val embeddings
    print("Loading CLIP")
    text_emb = clip_text(val_path_text, 1) # batched np array
    print("CLIP embeddings done:", text_emb.shape)
    with open(save_dir + 'data/waterbird_text_emb_val_clip.pkl', 'wb') as f:
        pickle.dump(text_emb, f)

    print("Loading GTR")
    text_emb = gtr_text(val_path_text, BATCH_SIZE) # batched np array
    print("GTR embeddings done:", text_emb.shape)
    with open(save_dir + 'data/waterbird_text_emb_val_gtr.pkl', 'wb') as f:
        pickle.dump(text_emb, f)


# CUDA_VISIBLE_DEVICES=0 python waterbird_text_emb.py
        